
# coding: utf-8

# # Lez 8

# ### Ricapitolazione Lez 7
# 
# - Soluzione Esercizio dei vincitore
# 
# - Manipolazioni di files
# 
# - Tuple
# 
# - Dizionari
# 

# ### File
# E' una sequenza di byte. E' scritto su disco! L'elemento atomico di struttura di base continua ad essere un byte, 8 bit! Dentro un singolo byte possiamo memorizzare un numero che va da 0 a 255, 2^8 possibilità. Dentro al byte c'è scritto un numero, il significato del byte dipende da come il byte viene interpretato. Un tempo le cose erano semplici 1byte=1carattere. Ora i numeri di byte associati ad un carattere sono variabili. C'è un meccanismo intermedio che decide quanti byte vengono messi insieme con una certa logica che dipende dal tipo di codifica. Dopo la codifica, il file diventa una sequenza di caratteri, con alcuni caratteri speciali.

# In[1]:

f = open("Esempi/provaTesto.txt")
f.read()


# In[2]:

f = open("Esempi/provaTesto.txt")
f.readlines()


# In[3]:

f = open("Esempi/provaTesto.txt")
f.readline()


# In[4]:

f = open("Esempi/provaTesto.txt")
f.readline().strip()


# In[5]:

f = open("Esempi/provaTesto.txt")
f.readline().strip().split(',')


# Il testo è un insieme di parole e separatore!

# In[6]:

f = open("Esempi/provaTesto.txt")
f.read(5)


# Non c'è una modalità giusta. Dipende da cosa cercate, dipende dal problema! Se devo analizzare un file, analizzare le parole, analizzare frequenza caratteri.

# ### Dizionario
# 
# è un insieme di oggetti {elem, elem, elem}
# 
# non c'è un ordine
# 
# elemento = < chiave > : < valore >

# In[7]:

d={}


# In[8]:

d['a']=ord('a')
d['b']=ord('b')
d['c']=ord('c')


# In[9]:

print(d['c'])


# In[10]:

print(d)


# La chiavi ed i valori possono essere qualunque cosa!!!

# In[11]:

d[1]='pere'
d[2]='mele'
d[3]='fragole'


# In[12]:

d[1]


# In[1]:

d[4]  # se richiamo chiavi non presenti mi da errore


# In[14]:

d


# L'ordine in cui sono stampati degli elementi è casuale e non è garantito!!!

# In[15]:

for elem in d:                  ### il for stampa le chiavi 
    print(elem)


# In[16]:

for chiave in d:                  ### il for stampa le chiavi 
    print(chiave, d[chiave])
    


# Per python gli elementi del dizionario sono le sue chiavi. Il dizionario è rappresentato dall'insieme delle sua chiavi! Un dizionario può essere visistato escusivamente tramite le sue chiavi!

# In[17]:

'pere' in d


# Per cercare tra i valore uso 

# In[19]:

list(d.values())


# In[20]:

'pere' in list(d.values())


# In[21]:

dizFreq={}
for i in range(26):  
    dizFreq[chr(ord('a')+i)]=0


# In[22]:

print(dizFreq)


# In[23]:

f_in=open("Esempi/provaTesto.txt")
c=f_in.read(1).lower()    # legge il primo carattere del file e lo converte in minuscolo
while c!='':           # il carattere vuoto in un file non c'è, solo quando il file finisce
    if 'a'<= c <='z':   # controlla che il carattere letto sia tra 'a' e 'z'
        # c.isalpha()
        dizFreq[c]+=1
    c=f_in.read(1).lower()  # legge il carattere successivo 


# In[24]:

print(dizFreq)


# In[25]:

def freqCaratDiz(file):
    f_in=open(file)
    dizFreq={}
    for i in range(26):  
        dizFreq[chr(ord('a')+i)]=0  #crea un dizionario {'a':0, 'b':0, ...}
    c=f_in.read(1).lower()    # legge il primo carattere del file e lo converte in minuscolo
    while c!='':           # il carattere vuoto in un file non c'è, solo quando il file finisce
        if 'a'<= c <='z':   # controlla che il carattere letto sia tra 'a' e 'z'
            dizFreq[c]+=1
        c=f_in.read(1).lower()  # legge il carattere successivo 
    return dizFreq 

f=freqCaratDiz("Esempi/TestoLungo.txt")
print(f)

 !!!!!!!     f_in=open(file,encoding = 'utf-8')      !!!!!!!!!
# In[37]:

def freqCaratDiz2(file):
    f_in=open(file)
    dizFreq={}
    c=f_in.read(1).lower()    # legge il primo carattere del file  e lo converte in minuscolo
    while c!='':           # il carattere vuoto in un file non c'è, solo quando il file finisce
        if c.isalpha():   # controlla che il carattere letto sia alfabetico
            if c in dizFreq:
                dizFreq[c]+=1  #la chiave esiste, incremento il contatore
            else:
                dizFreq[c]=1   #la chiave NON esiste creo un nuovo valore
        c=f_in.read(1).lower()  # legge il carattere successivo 
    return dizFreq 

fChr=freqCaratDiz2("Esempi/TestoLungo.txt")
print(fChr)


# In[27]:

len(fChr)


# In[28]:

l=list(fChr.keys())
l.sort()
for c in l:
    print(c,fChr[c], sep=':', end=',  ')


# In[29]:

print("Vocali")
for vocali in 'aeiou':
    print(vocali,fChr[vocali] )


# In[36]:

fChr.get('dddchsbcu','22')


# In[38]:

for k in fChr:      #stampa di tutte le lettere che compaiono più di 500 volte
    if fChr[k]>1000:
        print(k,fChr[k])


# In[39]:

lv = list(fChr.values())
lv.sort(reverse=True)
print(lv)


# In[41]:

for c in fChr:
    if fChr[c]==lv[0]:
        print(lv[0], c)


# ## Ex:
# fare una funzione che mi ritorna la frequenza delle parole in un testo. 

# In[5]:

def pulisciFile(file,ammissibili='0123456789abcdefghijklmnopqrstuvxywzàèéìòù'):
    f=open(file,encoding="UTF-8")
    stopList = ''
    s=f.read()
    f.close()
    for elem in s:
        elem = elem.lower()
        if elem not in ammissibili and elem not in stopList:
            stopList += elem
    #print(stopList)       
    for c in stopList:
        s = s.replace(c,' ')
    while s.find('  ') >= 0:
        s = s.replace('  ',' ')
    return s

def fParoleDiz(file_in):
    f={}
    parole=pulisciFile(file_in)  #tutto il file è in una stringa
    parole=parole.split()        #crea una lista di parole    
    for p in parole:
        if p in f:
            f[p]+=1
        else:
            f[p]=1
    return f          #<parola><frequenza>

f=fParoleDiz("Esempi/testoLungo.txt")

print(f)

for p in ['alfabeto']:
    print(p,f.get(p,0))


# ### Set
# 
# collezione di elementi senza duplicati

# In[42]:

a = set('abracadabra')
b = set('alacazam')
type(a)


# In[46]:

print('a =', a)


# In[47]:

print('b =', b)


# In[45]:

print ('a - b ', a - b)


# In[49]:

print ('a|b ' , a|b)


# In[50]:

print ('a&b ' , a&b)


# In[51]:

print ('a^b ' , a^b)


# ### Uso delle liste per pile e code
# 
# Lista: sequenza di elementi [elemento, elemento, elemento]
# 
# L'ordine della lista è l'unico modo per riconoscere gli elementi. Accesso sequenziale, visitabile tramite un indice!!! Posso metttere in ordine gli elementi solo se sono tutti dello stesso tipo!

# ### Stack
# In una pila l'elemento che si cancella è quello che viene inserito per ultimo. Lo stack implementa lo schema LIFO (Last In First Out) 
# ### Queues
# L'elemento cancellato è quello che è rimasto più tempo nell'insieme. La queues implementa lo schema FIFO (First In First Out)

# In[55]:

pila = [3, 4, 5]
pila.append(6)
pila.append(7)
print(pila)


# In[56]:

pila.pop()


# In[57]:

pila


# In[61]:

from collections import deque
queue = deque(["Beppe", "Marta", "Giulia"])
list(queue)


# In[63]:

queue.append("Erica")          
list(queue)


# In[64]:

queue.popleft()                 
queue                        


# ### Array

# In[73]:

import array


# In[75]:

a = array.array('i', range(1,4))


# In[76]:

a


# ### Ex : 
# Scrivere una funzione che valuta un'espressione scritta con la notazione polacca 
# https://it.wikipedia.org/wiki/Notazione_polacca
# 
# Consideriamo solo operazioni binarie: +,−,∗,/
# e solo valori interi

# Scannerizzare l’espressione da destra a sinistra
# 
# per ogni simbolo:
# 
# 	se il simbolo è un operando allora mettilo in una pila
#     
# 	se è un operatore op allora:
#     
# 		togli il primo elemento dalla pila e salvalo in x
#         
# 		togli il primo elemento dalla pila e salvalo in y
#         
#             spingi il risultato  x op y nella pila 
#             
# ritorna la testa della pila come risultato

# Hint:
# 
# Creare una funzione isoperator(elem) che valuta se elem è un operatore op = +,-,\,*. Creare una funzione comp(op,x,y) che dato un operatore op e due numeri x, y mi ritorna il risultato dell'operazione z = x op y . Creare una funzione polf(s) che scansione da destra gli elementi di s, se sono operandi li aggiunge ad una pila se sono operatori (lo valuta usando la funz isoperator(elem) ) rimuove dalla pila gli ultimi due elementi x,y e aggiunge alla pila il risultato di comp(op,x,y).

# In[ ]:



